case $CONFIG in
    '') . conf.sh ;;
esac
echo "Extracting config.h (with variable substitutions)"
cat >config.h <<!GROK!THIS!
/*
 * Find the place marked "EDIT HERE", and do so.
 */

#ifndef lint
#ifdef GEN_ID
static char config_h_Id[] =
    "$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/config.SH,v 2.13 2000/02/08 08:56:42 geoff Exp $";
#endif
#endif

/*
 * $Log: config.SH,v $
 * Revision 2.13  2000/02/08 08:56:42  geoff
 *
 * Integrate various changes from Geoff's branch into the now-master CVS
 * repository.  As part of this integration, I cleaned up some, but not
 * all, of the inconsistent coding style introduced by the LOC_CRON
 * changes.  Important and substantive changes include:
 *
 *     Configure	Add errlist_in_stdio and getitimer/sigprocmask support.
 *     Makefile.SH	Tiny cleanup to an expr command.
 *     config.SH	Add errlist_in_stdio and getitimer/sigprocmask support.
 *     errmsg.c	Add errlist_in_stdio support.
 *     mainloop.c	Use setjmp/longjmp to ensure that we are blown off the
 * 		select when we catch an alarm, even if we are running
 * 		on a system that has reliable signals.  Also add
 * 		reliable-signal support that properly resets the
 * 		signal mask in the longjmp case.
 *     parse.c	Fix a bug that could cause crontabs to be accepted
 * 		with the wrong UID.  Be a bit more careful about
 * 		parsing years.
 *     runcmd.c	Add setjmp/longjmp and reliable-signal support.  (See
 * 		mainloop.c).
 *     xcron.c	Use setitimer to make absolutely sure that all alarms
 * 		are disabled at startup.
 *
 * Revision 2.12  1999/07/27 01:22:00  johnh
 * location support for at jobs
 *
 * Revision 2.11  1999/07/14 05:22:30  johnh
 * location awareness (all in LOC_CRON) and a few cleanups/bugfixes
 *
 * Revision 2.10  1998/07/30 20:42:22  geoff
 * Many changes, accumulated over far too much time: add longnames,
 * ftruncate, and automounter support.
 *
 * Revision 2.9  1995/11/27  01:59:25  geoff
 * Add hasmktime, EDITTEMP, NOHOME, and DEFEDITOR.
 *
 * Revision 2.8  1995/05/11  05:05:05  geoff
 * Support variable signal types, and variable UID/GID for root.
 *
 * Revision 2.7  88/10/31  23:53:26  geoff
 * Remove comments about streams as a communication option (named pipes are
 * better).  Improve the commentary about TEMPBASE.
 * 
 * Revision 2.6  87/03/31  22:32:14  geoff
 * Add string[s].h selection variables.
 * 
 * Revision 2.5  87/01/10  19:14:04  geoff
 * Add some more configuration options.
 * 
 * Revision 2.4  86/11/29  16:44:05  geoff
 * Add support for varying numbers of registers.  Add HASSETPGRP and
 * SETPGRPARGS.
 * 
 * Revision 2.3  86/11/16  00:57:32  geoff
 * Major changes to turn config.h into config.SH and make it work with
 * Larry Wall's configuration script.
 * 
 * Revision 2.2  86/04/17  21:54:48  geoff
 * Add allow/deny support and a compile-able RCS ID.
 * 
 * Revision 2.1  86/04/13  16:24:47  geoff
 * Initial revision
 * 
 */

#include "defs.h"

/*
 * Target system characteristics
 *
 * EDIT HERE
 */

/*
 * Directory and file path names.  Note that the library directory can be
 * relative to CRONTABDIR (it must also be valid relative to ATJOBDIR).
 * In addition, CRONTABDIR itself can be a relative pathname;  in this case
 * it must be relative to LIBDIR and cron must be run from LIBDIR.
 *
 * You probably won't want to change these.
 */
#define ATJOBDIR	"$spool/atjobs"		/* "at" job dir name */
#define CRONTABDIR	"$spool/crontabs"	/* Crontab directory */
#define LIBDIR		"$lib"			/* System cron library */

/*
 * If your system supports long filenames in the cron/at spool directory,
 * enable the following definition.
 */
#$longnames		LONGNAMES		/* Long filename support */

/*
 * Root UID/GID.  This uid/gid combination is used to verify that cron
 * was started by the superuser.  It should match the UID/GID of 'root'
 * in the password file.
 */
#define ROOTGID		$rootgid		/* Group ID of root */
#define ROOTUID		$rootuid		/* User ID of root */

/*
 * Daemon UID/GID.  This uid/gid combination is used when sending mail,
 * so that the mail appears to come from 'daemon' rather than 'root'.
 * It should match the UID/GID of 'daemon' in the password file.  If
 * your password file does not have a 'daemon' entry, use root's ID
 * for both values.
 */
#define DAEMONGID	$daemongid		/* Group ID of daemon */
#define DAEMONUID	$daemonuid		/* User ID of daemon */

/*
 * USG/PWB systems use strchr/strchr, to avoid conflicting with common
 * variable names.  V7/BSD systems do not.  Enable the following two
 * definitions on V7/BSD systems.
 */

#$strchr strchr		index			/* For V7 and BSD systems */
#$strchr strrchr	rindex			/* For V7 and BSD systems */

/*
 * If your system has vfork, disable the following definition.
 */
#$novfork vfork		fork			/* For V7 and USG systems */

/*
 * How to make use of the directory libraries
 */
#$libndir LIBNDIR				/* System has ndir.h */
#$usendir USENDIR				/* We must provide ndir.c */

/*
 * How many register declarations are paid attention to
 */
#define reg1	$reg1
#define reg2	$reg2
#define reg3	$reg3
#define reg4	$reg4
#define reg5	$reg5
#define reg6	$reg6
#define reg7	$reg7
#define reg8	$reg8
#define reg9	$reg9
#define reg10	$reg10
#define reg11	$reg11
#define reg12	$reg12
#define reg13	$reg13
#define reg14	$reg14
#define reg15	$reg15
#define reg16	$reg16

/*
 * The data structure used to represent cron requests is a bit mask.
 * MASKTYPE should be a basic C type (char, int, short, or long) that is
 * efficiently handled in your architecture.  On most systems, this is
 * char.  If you do not have byte addressing, use short or int.  A few
 * compilers that generate special code for bit masking might even
 * benefit from a MASKTYPE of long, but I sort of doubt it.
 *
 * Whatever you define MASKTYPE as, you must also define BITSPERMASK as the
 * number of bits it will hold.  There is no requirement that you tell
 * the truth (e.g., on a 9-bit machine it's fine to set BITSPERMASK to 8).
 * MASKMASK must be defined as a mask for all the bits in a MASKTYPE.
 * It should match the actual value of BITSPERMASK (e.g., on our
 * hypothetical 9-bit machine with 8-bit BITSPERMASK, it should be 0xFF).
 */

#define MASKTYPE	$masktype		/* Base type for bit masks */
#define BITSPERMASK	$maskbits		/* Bits in a MASKTYPE */
#define MASKMASK	$maskmask		/* Mask for a MASKTYPE */

/*
 * Character mask.  This is used to make sure certain routines return
 * positive values, even on machines that don't have unsigned characters.
 */
#define CHARMASK	$charmask		/* Mask for byte in int */

/*
 * Minor system variations.
 */
#$fcntl HASFCNTL				/* System has fcntl.h */
#$ftruncate HASFTRUNCATE			/* System has ftruncate() */
#$rename HASRENAME				/* System has rename() */
#$setpgrp HASSETPGRP				/* System has setpgrp () */
#$setpargs SETPGRPARGS				/* Setpgrp() takes arguments */
#$truncate HASTRUNCATE				/* System has truncate() */
#$errlist_in_stdio ERRLIST_IN_STDIO		/* Sys_errlist is in stdio.h */

/*
 * Signal-handling type definition.
 */
#define SIG_TYPE $sigtype			/* Type of signal handlers */

/*
 * How to figure out the system time zone.
 */
#$ftime FTIME					/* System has ftime() */
#$gettimeofday GETTIMEOFDAY			/* System has gettimeofday() */
#$hastzset HASTZSET				/* System has tzset() */
#ifndef FTIME
#ifndef GETTIMEOFDAY
#ifndef HASTZSET
#define TZOFFSET	($tzoffset * 60)	/* Time zone offset */
#define DAYLIGHT	($daylight)		/* We use daylight savings */
#endif
#endif
#endif

/*
 * How to do timers
 */
#$getitimer HASGETITIMER			/* System has getitimer() */

/*
 * Whether BSD or POSIX-style signals are supported
 */
#$sigprocmask HASSIGPROCMASK			/* System has sigprocmask() */
#ifdef HASSIGPROCMASK
#undef RELIABLE_SIGNALS				/* Don't need BSD signals */
#else /* HASSIGPROCMASK */
#$relsig RELIABLE_SIGNALS			/* System has reliable sigs */
#endif /* HASSIGPROCMASK */

/*
 * How to convert a struct tm into a time_t.
 */
#$hasmktime HASMKTIME

/*
 * If you have a BSD system, or some other system which requires an
 * initgroups call, enable the following.
 */
#$initgroups IGROUPS				/* Do an initgroups call */

/*
 * FIFO type selection.  The routines in the module "fifo.c" support a
 * named-pipe (USG FIFO) type on most systems.  Select the first option
 * in the following list that your system supports.
 *
 * Flavors available:
 *
 * USGFIFO	USG named pipes
 * BSDSOCKET	BSD sockets
 * VANILLA	UNIX file system
 *
 * NOTE:  BSDSOCKET is not currently debugged.
 */

#define $fifotype

/*
 * Temporary file selection.  If you want cron's temp files to go in a
 * different directory, change the directory part of this string.
 * The filename part of the string must contain a 'o' just before the
 * six (or more) X's.
 *
 * If you change the number of X's, you will also have to change the
 * constant 12 or 17 in TEMPTYPELOC.
 */
#ifdef LONGNAMES
#define TEMPBASE	"$tempdir/crnoXXXXXXXXXXXXXXX"
#define TEMPSIZE	((sizeof TEMPBASE) + 1)
#define TEMPTYPELOC	(TEMPSIZE - 1 - 17)
#else /* LONGNAMES */
#define TEMPBASE	"$tempdir/crnoXXXXXXXXXX"
#define TEMPSIZE	((sizeof TEMPBASE) + 1)
#define TEMPTYPELOC	(TEMPSIZE - 1 - 12)
#endif /* LONGNAMES */

/*
 * Temporary file names for cron files that are being edited.  See the
 * comments above for TEMPBASE.
 */
#ifdef LONGNAMES
#define EDITTEMP	"$tempdir/ceXXXXXXXXXXXXXX"
#else /* LONGNAMES */
#define EDITTEMP	"$tempdir/ceXXXXXXXX"
#endif /* LONGNAMES */

/*
 * Current directory to use if the user doesn't have a home defined.
 */
#define NOHOME		"$tempdir"

/*
 * Default editor to use, if the user doesn't specify either EDITOR or
 * VISUAL.
 */
#define DEFEDITOR	"$defeditor"

/*
 * Mailer selection, for reporting the results of program runs.  The mailer
 * must accept the destination user's name as the first argument, and the
 * message on stdin.
 */
#define MAILER		"$mailer"
#define MAILARGV0	"`expr $mailer : '.*/\(.*\)'`"

/*
 * Some mailers (e.g., V7, S5.0) don't lock the mail file properly if
 * two mailings are spawned simultaneously.  This parameter gives the
 * time to sleep between two successive mailings to the same user to
 * allow mail time to lock properly.  (Note:  this is only enforced when
 * the two mailings are the standard error and standard output of the
 * same command.)
 */
#$mailsleep MAILLOCKSLEEP	10	/* Sleep 10 secs between stdout/err */

/*
 * If your system doesn't have memset(), define the following.
 */
#$mymemset MYMEMSET			/* Use private version of memset() */

/*
 * Selection of where strings.h comes from
 */
#$stringh STRINGH			/* Strings.h from string.h */
#$stringsh STRINGSH			/* Strings.h from strings.h */
#$mystringh MYSTRINGH			/* Strings.h from pstring.h */

/*
 * Default environment selection.  These environment variables are always
 * passed as constants.  TZ is passed from cron's environment, if it is
 * available.  HOME and LOGNAME come from /etc/passwd;  there is no other
 * environment.
 */
#define DEFPATH		"PATH=$defpath"	/* Everybody's path */
#define DEFSHELL	"SHELL=/bin/sh"	/* Everybody's forced shell (yuck) */
#define ENVHOME		"HOME="
#define ENVLOGNAME	"LOGNAME="
#define ENVTZ		"TZ="

/*
 * Mount point used by automounter.  This is stripped off the CWD by
 * 'at' so that the automounter (if any) will get a chance to re-mount
 * the appropriate filesystem when the at job runs.
 */
#define AUTOMOUNTPOINT	"$automountpoint" /* Where automounter mounts */

/*
 * Type of nice levels used on your systems.  Define RELNICE if nice(2)
 * takes a relative number.  Undefine it if nice(2) takes an absolute
 * number.
 *
 * If RELNICE is defined, MINNICE/MAXNICE define the resultant nice range
 * imposed by the system.  If RELNICE is undefined, MINNICE/MAXNICE define
 * the range of values nice(2) will accept;  typically MINNICE is negative
 * in this case.
 */
#$relnice RELNICE		/* Nice(2) takes a relative number */
#define MINNICE	$minnice	/* Minimum nice value */
#define MAXNICE	$maxnice	/* Maximum nice value */

/*
 * Language selection.  If your language isn't in here, add a #define for
 * your language and a table of month and day names.  To the Germans out
 * there, I apologize if my abbreviations are wrong.  Also, I apologize
 * to everyone for making you put up with English error messages regardless.
 * (That's why Configure doesn't ask about this).  Maybe some day...
 */
#define ENGLISH			/* Use English month and day names */
/* #define DEUTSCH		/* Use Deutsch (German) month and day names */

/*
 * Initializers for the day/month name arrays, based on languages.
 * In all languages, the table should be all lowercase;  the crontab entries
 * are mapped to lowercase before comparison.
 *
 * Although all the samples are three characters long, there is no need for
 * this.  The entries do not even have to be consistent in length, but the
 * user is required to use the whole string given here.
 *
 * Order is important!
 */
#ifdef ENGLISH
#define DAYNAMES	{ "sun", "mon", "tue", "wed", "thu", "fri", "sat" }
#define MONTHNAMES	{ "jan", "feb", "mar", "apr", "may", "jun", "jul", \
			"aug", "sep", "oct", "nov", "dec" }
#endif
#ifdef DEUTSCH
#define DAYNAMES	{ "son", "mon", "die", "mit", "don", "fre", "sam" }
#define MONTHNAMES	{ "jan", "feb", "mar", "apr", "mai", "jun", "jul", \
			"aug", "sep", "okt", "nov", "dez" }
#endif

/*
 * Location-dependent cron stuff
 */
#$lcronok LOC_CRON 1
#ifdef LOC_CRON 
#define LOC_MOVE 1
#define LOC_EVENTSDIR 1
#define LOC_ATLOC
#endif

/*
 * END OF PARAMETERS THAT NEED EDITING
 */
!GROK!THIS!
