#ifndef lint
#ifdef GEN_ID
static char defs_h_Id[] =
    "$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/defs.h,v 1.3 1999/07/13 19:12:18 geoff Exp $";
#endif
#endif

/*
 * This header file contains general definitions that you may want to
 * change, but probably won't.
 */

/*
 * $Log: defs.h,v $
 * Revision 1.3  1999/07/13 19:12:18  geoff
 * Add a bunch of new symbols to be used to limit resource consumption.
 * Also add some umasks for better security.
 *
 * Revision 1.2  1995/11/27  01:59:38  geoff
 * Fix a minor tabbing error.
 *
 * Revision 1.1  1995/10/11  02:33:23  geoff
 * Initial revision
 *
 */

/*
 * Debugging suboptions
 */
#ifndef YYDEBUG
# define YYDEBUG	0
#endif
#if YYDEBUG
# ifndef DEBUG
#  define DEBUG			/* If YYDEBUG, force DEBUG */
# endif
#else
# ifdef DEBUG
#  undef YYDEBUG
#  define YYDEBUG	1	/* Similarly, if DEBUG force YYDEBUG */
# endif
#endif
#ifdef DEBUG
# ifndef DUMP
#  define DUMP			/* If DEBUG, force DUMP */
# endif
#endif

/*
 * Directory and file path names.
 */
#define ALLOW		".allow"		/* Allow file suffix */
#define ATPRIV		"at"			/* Prefix for at privileges */
#define CRONLOG		"log"			/* System cron log file */
#define CRONPRIV	"cron"			/* Prefix for cron privs */
#define DENY		".deny"			/* Deny file suffix */
#define FIFONAME	"FIFO"			/* FIFO for communications */
#define LIMITFILE	"userlimits"		/* Limitations, in LIBDIR */
#define LOCKFILE	"lock"			/* Lock file, goes in LIBDIR */
#define LOCKLINK	"cl.%d"			/* Link to LOCKFILE */
#define TIMELOG		"crontime"		/* Time cron last ran */
						/* ..goes in LIBDIR */

/*
 * Default per-user process limit.  If a particular UID tries to spawn more
 * jobs than this (whether from cron or from at), they will be held pending
 * until the current jobs finish.
 */
#define DEFPROCLIM	5			/* User can have 5 processes */

/*
 * Default limit on the process queue.  When DEFPROCLIM is exceeded,
 * processes are held pending on a queue.  When DEFQLIM is exceeded, processes
 * are discarded.
 */
#define DEFQLIM		(DEFPROCLIM * 4)	/* User can queue 20 procs */

/*
 * Default nice level to run cron and at jobs at.  Like DEFPROCLIM, can
 * be overridden in the 'userlimits' file.
 */
#define DEFNICE		4			/* Run at a slightly low pri */

/*
 * Default per-user limit on cron job entries.  This includes both
 * cron lines and at jobs.
 */
#define DEFENTLIM	100			/* 100 jobs max */

/*
 * Default per-user limit on cron job sizes.  This limits the
 * command-line length.
 */
#define DEFENTSIZELIM	1024			/* Put long jobs in scripts! */

/*
 * Default per-user limit on mail size.  This limits the length of
 * mail sent by cron.
 */
#define DEFMAILSIZELIM	200000			/* Allow fairly long mail */

/*
 * Shell to use to run cron commands (note that the user's shell is *not*
 * used).
 */
#define CMDSHELL	"/bin/sh"
#define CMDARGV0	"sh"			/* What to give as argv[0] */

/*
 * Shell to use to run at jobs (note that the user's shell is *not* used).
 */
#define ATSHELL		CMDSHELL
#define	ATARGV0		CMDARGV0

/*
 * Default directory.  Cron chdir's here if it can't cd to the user's home.
 * It also cd's here before exec-ing the mailer.
 */
#define SAFEHOME	"/"

/*
 * Null input provider.
 */
#define NULLINPUT	"/dev/null"

/*
 * Huge time selection.  You need change this only if you use less than 32
 * bits to represent time_t.
 */
#define HUGETIME	((time_t) 0x7FFFFFFF)

/*
 * Umask to be used for cron itself
 */
#define CRONUMASK	077		/* Very paranoid */

/*
 * Umask to be used when firing off jobs
 */
#define JOBUMASK	022		/* Not very restrictive */
