#! /bin/sh

#
# location_monitor.sh
# Copyright (C) 1999 by John Heidemann
# $Id: location_monitor.sh,v 1.1 2000/04/13 04:31:53 johnh Exp $
#

usage () {
    cat 1>&2 <<END
usage: $0

monitor and filter location, sending signals to lcron if it changes
END
    exit 1
}

BASE=/usr/local/lib/xcron
BINDIR=$BASE/bin
LIBDIR=$BASE/lib


check () {
	echo check

	/bin/netstat -rn | while read line
	do
		set -- $line
		case $2 in
		0.0.0.0|Gateway|IP) : ;;
		*) echo $2;;
		esac
	done > $LIBDIR/events/netstat

	/bin/cat $LIBDIR/events/netstat | while read line
	do
		g=`grep "^$line " <  $LIBDIR/netstat_mapping`
		set -- $g
		test "x$2" != x && echo $2
	done

	$BINDIR/tellxcron -L
}


daemon_mode () {
	# catch sigio
	trap check SIGIO
	trap 'exit 0' SIGHUP
	trap 'exit 1' SIGINT SIGTERM

	check
	while :
	do
		sleep 600
	done
	echo "error: demon mode escaped infinte loop"
	exit 0
}


#
# main
#

test "x$1" = 'x-?' && usage

test "x$1" = x-D && daemon_mode

check

exit 0





