#ifndef lint
static char Rcs_Id[] =
    "$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/tzset.c,v 1.2 1995/05/11 05:06:03 geoff Exp $";
#endif

/*
 * $Log: tzset.c,v $
 * Revision 1.2  1995/05/11 05:06:03  geoff
 * Minor RCS header changes.
 *
 * Revision 1.1  87/03/31  21:11:07  geoff
 * Initial revision
 * 
 */

#include "config.h"
#include <time.h>
#ifdef GETTIMEOFDAY
#include <sys/time.h>
#endif
#ifdef FTIME
#include <sys/types.h>
#include <sys/timeb.h>
#endif

#ifndef HASTZSET
long		daylight;		/* NZ if DST applies here */
long		timezone;		/* System timezone, in seconds */

void tzset ()				/* Set timezone information */
    {
#ifdef GETTIMEOFDAY
    struct timeval	tv;		/* Where gettimeofday returns time */
    struct timezone	tz;		/* Where gettimeofday returns zone */

    (void) gettimeofday (&tv, &tz);	/* Get time zone info */
    timezone = tz.tz_minuteswest * 60;	/* Convert to seconds */
    daylight = tz.tz_dsttime;
#endif
#ifdef FTIME
    struct timeb	tbuf;		/* Return struct for ftime call */

    (void) ftime (&tbuf);		/* Find out system timezone */
    timezone = (long) tbuf.timezone * 60; /* Convert it to seconds */
    daylight = tbuf.dstflag;
#endif
#ifdef TZOFFSET
    timezone = TZOFFSET;
    daylight = DAYLIGHT;
#endif
    }
#endif
